package com.afeiamic.springcloud.controller;

import com.afeiamic.springcloud.service.PaymentService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@Slf4j
public class PaymentController {

    @Resource
    private PaymentService paymentService;

    @Value("${server.port}")
    private String serverPort;

    @GetMapping("/payment/hystrix/ok/{id}")
    public String paymentInfo_OK(@PathVariable("id") Integer id) {
        String ret = paymentService.paymentInfo_OK(id);
        log.info("=========> ret: {} <=========", ret);
        return ret;
    }

    @GetMapping("/payment/hystrix/timeout/{id}")
    public String paymentInfo_Timeout(@PathVariable("id") Integer id) {
        String ret = paymentService.paymentInfo_Timeout(id);
        log.info("=========> ret: {} <=========", ret);
        return ret;
    }

    // ===>服务熔断
    @GetMapping(value = "/payment/circuit/{id}")
    public String paymentCircuitBreaker(@PathVariable("id") Integer id) {
        String ret = paymentService.paymentCircuitBreaker(id);
        log.info("========> PaymentController.paymentCircuitBreaker ret: {}", id);
        return ret;
    }
}
