package com.afeiamic.springcloud.service;

import com.afeiamic.springcloud.entities.Payment;
import com.afeiamic.springcloud.entities.R;
import com.afeiamic.springcloud.service.fallback.PaymentFallbackService;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

/**
 * 使用 fallback 方式是无法获取异常信息的,
 * 如果想要获取异常信息，可以使用 fallbackFactory 参数
 */
@FeignClient(value = "nacos-payment-provider", fallback = PaymentFallbackService.class) // 调用过程中关闭9003服务者
public interface PaymentService {

    @GetMapping(value = "/paymentSQL/{id}")
    public R<Payment> paymentSQL(@PathVariable("id") Long id);
}
